#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>

void convert_endian(unsigned int *endian_data){
 *endian_data = (((*endian_data&0xFF)<<24)|((*endian_data&0xFF00)<<8)|((*endian_data&0xFF0000)>>8)|(*endian_data>>24));
}



 /*------------------------------------------------------------------*/
 /*             Main routine                                         */
 /*------------------------------------------------------------------*/
int main(int argc, char **argv){
 int i,j;

 if(argc==1){
  printf("XP3 to PNG converter. 1.0.0\r\n");
  printf("Get png files from xp3 files or other database. No Encryped file.\r\n");
  printf(" If you see the header of the png in the binary, probably it will work.\r\n");
  printf("usage : xp32png.exe E:\\example_folder\\example.xp3 \r\n");
  return 0;
 }
 FILE *fp;
 fp = fopen(argv[1],"rb");
 if(fp==NULL){
   printf("Cannot open this file : %s\r\n",argv[1]);
   return 1;
 }
 int pngcount = 0;
 char chunkstr[8] = {0,0,0,0,0,0,0,0};
 char outpath[1000] = "";
 unsigned char pngheader[8] = {0x89,0x50,0x4e,0x47,0x0d,0x0a,0x1a,0x0a};

 int testcount = 0;
 while(1){
  FILE *wp;
  i = 0;
  while(i<8 && getc(fp)==pngheader[i])i++;
  testcount++;
  if(i==8){
   pngcount++;
   sprintf(outpath,"DMP%05d.png",pngcount);
   wp = fopen(outpath,"wb");
   if(wp==NULL){
    printf("Output path %s is not available.\r\n",outpath);
    return 2;
   }
   printf("Started png file %5d.\r\n",pngcount);
   fwrite(pngheader,1,8,wp);
   int continue_flag = 1;
   while(continue_flag){
    unsigned int chunksize;
    fread(&chunksize,4,1,fp);
    fwrite(&chunksize,4,1,wp);
    convert_endian(&chunksize);
    fread(chunkstr,1,4,fp);
    fwrite(chunkstr,1,4,wp);
    if(strcmp(chunkstr,"IEND")==0)continue_flag = 0;
    //printf("READ CHUNK %s. SIZE=%8x.\r\n",chunkstr, chunksize);
    for(j=0;j<chunksize+4;j++){
     putc(getc(fp),wp);
    }
    if(feof(fp)!=0 || feof(fp)!=0){
     printf("ERROR!!!\r\n");
     continue_flag = 0;
    }
   }
   fclose(wp);
  }
  if(ferror(fp)!=0){
   printf("ERROR!\r\n");
   break;
  }
  if(feof(fp)!=0){
   printf("FINISHED.\r\n");
   break;
  }
 }
 fclose(fp);
 printf("Finished %d pngs(everything).testcount:%d.\r\n",pngcount,testcount);
 return 0;
}

